# ICore

## Functions

### init

```solidity
function init() external
```

### setChi

```solidity
function setChi(
    address token
) external
```

#### Parameters

| Name    | Type    | Description |
| ------- | ------- | ----------- |
| `token` | address |             |

### setZen

```solidity
function setZen(
    address token
) external
```

#### Parameters

| Name    | Type    | Description |
| ------- | ------- | ----------- |
| `token` | address |             |

### allocateZen

```solidity
function allocateZen(
    address to,
    uint256 amount
) external
```

#### Parameters

| Name     | Type    | Description |
| -------- | ------- | ----------- |
| `to`     | address |             |
| `amount` | uint256 |             |

### chi

```solidity
function chi() external returns (contract IChi)
```

### zen

```solidity
function zen() external returns (contract IERC20)
```

## Events

### ChiUpdate

```solidity
event ChiUpdate(
    address _chi
)
```

#### Parameters

| Name          | Type    | Description |
| ------------- | ------- | ----------- |
| `_chi`        | address |             |
| ### ZenUpdate |         |             |

```solidity
event ZenUpdate(
    address _zen
)
```

#### Parameters

| Name   | Type    | Description |
| ------ | ------- | ----------- |
| `_zen` | address |             |

### ZenAllocation

```solidity
event ZenAllocation(
    address _to,
    uint256 _amount
)
```

#### Parameters

| Name      | Type    | Description |
| --------- | ------- | ----------- |
| `_to`     | address |             |
| `_amount` | uint256 |             |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.essencefinance.io/development/smart-contracts/core/icore.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
